<?php

namespace Teknisa\CADEST\Modules\Produto\Controllers;

use \Zeedhi\Framework\DTO\Request;
use \Zeedhi\Framework\DTO\Response;
use \Zeedhi\Framework\DataSource\ParameterBag;
use \Zeedhi\Framework\DataSource\DataSet;
use \Teknisa\Libs\Service\CRUD;

class Estruarvoreprod extends \Teknisa\CADEST\Controllers\TeknisaCrud{

	protected $dataSourceName = 'estruarvoreprod_estruarvoreprod';
	protected $dataSourceNameToSave = 'estruarvoreprod';
	protected $parameterBag = array();

	function __construct(CRUD $crudService, ParameterBag $parameterBag){
		$this->parameterBag = $parameterBag;
		parent::__construct($crudService, $parameterBag);
	}

	public function find(Request\Filter $request, Response $response){
		$filterCriteria = $request->getFilterCriteria();
        $conditions = $filterCriteria->getConditions();
        
        parent::find($request, $response);

        $dataSets = $response->getDataSets();
        if (count($dataSets) > 0) {
            $rows = $dataSets[0]->getRows();

            $rows = array_map(function($row) {
                $row['_hasChild'] = $row['HASCHILD'] === 'true' ? true : false;
                unset($row['HASCHILD']);
                return $row;
            }, $rows);

            $response->setDataSets(array(new DataSet('estruarvoreprod_estruarvoreprod', $rows)));
        }
	}

    public function findForFilter(Request\Filter $request, Response $response){
		$filterCriteria = $request->getFilterCriteria();
        $conditions = $filterCriteria->getConditions();

        $this->dataSourceName = 'estruarvoreprod_estruarvoreprod_for_filter';

        $existNrarvoreprod = false;
        $existArvoreprodpai = false;
        
        foreach ($conditions as $value) {
            if ($value['columnName'] === 'NRARVOREPROD') {
                $existNrarvoreprod = true;
            } else if ($value['columnName'] === 'ARVOREPRODPAI') {
                $existArvoreprodpai = true;
            }
        }

        if ($existNrarvoreprod && !$existArvoreprodpai) {
            $filterCriteria->addCondition('ARVOREPRODPAI', 'T');
        }
        
        parent::find($request, $response);

        $dataSets = $response->getDataSets();
        if (count($dataSets) > 0) {
            $rows = $dataSets[0]->getRows();

            $rows = array_map(function($row) {
                $row['_hasChild'] = $row['HASCHILD'] === 'true' ? true : false;
                unset($row['HASCHILD']);
                return $row;
            }, $rows);

            $response->setDataSets(array(new DataSet('estruarvoreprod_estruarvoreprod_for_filter', $rows)));
        }
	}

}